#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# ZetpeR xax007@yandex.ru
# PS2 Hana To Otome ni Shukufuku o Harukaze no Okurimono распаковка сжатия .1tex и конвектор картинок
# Время распаковки всех файлов занимает примерно 8 минут

import os, sys
import struct
import time
import datetime
import io
from PIL import Image

path = os.path.realpath(os.path.dirname(sys.argv[0]))

class Profiler(object):
    def __enter__(self):
        self._startTime = time.time()
    def __exit__(self, type, value, traceback):
        dd = time.time() - self._startTime
        seconds_f, mikro = str(dd).split(".")
        print("Часы минуты секунды",str(datetime.timedelta(seconds=int(seconds_f))),"", "{:.3f} sec".format(time.time() - self._startTime))

def main():
    if os.path.exists(path+"\\Unpack") == False:
        os.makedirs(path+"\\Unpack")
    with Profiler() as p:
        for mult_file in os.listdir(path):
            if mult_file.lower().endswith(('.1tex')):
                Unpack(mult_file)
    print("Закрыть")

def Unpack(mult_file):
    f = open(path+"\\"+mult_file,"rb")
    fd = f.read()
    f.close()
    f = io.BytesIO(fd) # Загружаем файл в память Для быстрой работы

    type = f.read(4)
    if type != b'1tex': # Проверка
        print("ЭТО НЕ сжатый файл",type,mult_file)
        return(0) # Остановка скрипта

    f2 = io.BytesIO()

    unclear = f.read(4) # Непонятно
    HEX = unclear.hex(' ').upper()
    print(mult_file,"4 байта непонятно",HEX)

    while True:
        check = f.read(1)[0] # Управляющий байт

        if check == 0x00: # Конец файла
            #print("Конец файла\n")
            break

        elif check >= 0x80: # Сколько прочитать байт
            col = (0xFF-(check))+3 # Сколько прочитать байт

            back = struct.unpack("B",f.read(1))[0] +1 # Насколько байт отойти назад
            posf = f2.tell() - back # Позиция чтения
            for j3 in range(col): # Сколько прочитать байт
                f2.seek(posf) # Преход на нужное место
                fd = f2.read(1) # Читаем байт
                f2.seek(0,2) # Перейти в конец файла
                f2.write(fd) # Запись байта
                posf += 1

            #print("Сколько прочитать байт из распакованного файла",col)

        else: # check <= 0x7F:
            #print("Записать байтов",check)
            fd = f.read(check) # Просто читаем байты
            f2.write(fd)

    f.close()

    #f3 = open(path+"\\Unpack\\"+mult_file[:-5]+".bin", "wb")
    #f2.seek(0)
    #fd = f2.read()
    #f3.write(fd)
    #f3.close()

    Unpack_2(f2, mult_file[:-5]) # Конвертация картинок

    f2.close()

def Unpack_2(f, mult_file):
    ss = 0 # Счётчик файлов

    f.seek(0,2)
    end_f = f.tell() # Конец файла
    f.seek(0)

    while True:
        ss += 1
        if f.tell() == end_f-16: # Конец файла
            #print("Конец файла")
            break

        type = f.read(2) # Заголовок T2
        w, h = struct.unpack("<HH",f.read(4)) # Ширина и высота
        unclear = f.read(26) # Непонятно
        fd = f.read(w*h)

        # Чтение палитры и конвертация палитры Tim2 в правильную
        unclear_2 = f.read(32) # Заголовок с данными

        Pal = bytearray()
        for i in range(8):
            block1 = f.read(32)
            block2 = f.read(32)
            block3 = f.read(32)
            block4 = f.read(32)
            Pal += block1 + block3 + block2 + block4

        for i in range(3, 4*256, 4):
            Pal[i] = scale_alpha(Pal[i])
        Pal = tuple(tuple(Pal[i*4:i*4+4]) for i in range(256))

        im = Image.new("RGBA", (w, h))
        im.putdata(tuple(Pal[c] for c in fd))
        im.save(path+"\\Unpack\\"+mult_file+" "+str(ss)+".png", "PNG")
        im.close()
    f.close()

def scale_alpha(a):
    return int(min(255.0 * (a / 128.0), 0xFF))

if __name__ == "__main__":
    main()
    input()